program GenericListTest;
uses SysUtils, FGL;
type
   TPerson = class
      Name : String;
      Age : Integer;
      constructor Create (aName : String; anAge : Integer);
   end;
   TPersonList = specialize TFPGList<TPerson>;
   constructor TPerson.Create (aName : String; anAge : Integer);
   begin
      Name := aName; Age := anAge
   end;
var
   MyList: TPersonList;
   Person: TPerson;
begin
   MyList := nil;
   try
      MyList := TPersonList.Create;
      MyList.Add (TPerson.Create ('Alice', 24));
      MyList.Add (TPerson.Create ('Bob', 27));
      for Person in MyList do
         WriteLn ('person: ', Person.Name, ' age ', Person.Age);
   finally
      if MyList <> nil then
      begin
         for Person in MyList do
            Person.Free;
         MyList.Free
      end
   end
end.