program GenericMapTest;
uses SysUtils, FGL;
type
   TStrIntMap = specialize TFPGMap<String, Integer>;
var
   MyMap : TStrIntMap;
   pos : Integer;
   Name : String;
begin
   MyMap := nil;
   try
      MyMap := TStrIntMap.Create;
      MyMap.Add ('Zabini', 21);
      MyMap.Add ('Bob', 27);
      MyMap.Add ('Alice', 24);
      MyMap.Sort;               {Without sorting won't find Alice!}
      Write ('Find person: '); ReadLn (Name);
      if MyMap.Find (Name, pos)
      then WriteLn ('Found ', Name, ': age ', MyMap.Data[pos])
      else WriteLn ('Not found ', Name)
   finally
      MyMap.Free
   end
end.